module Useful (
 enumerateShow, takeUntil, int2integer, changeFileExtension, extractFromMaybe, showError
) where

import Char
import List
import IO

int2integer = toInteger

takeUntil _ [] = []
takeUntil p (x:xs)
  | p x       = [x]
  | otherwise = x:takeUntil p xs

enumerateShow :: (a -> String) -> [a] -> String
enumerateShow x_show xs = 
  unlines (zipWith (\n x -> show n++". "++x_show x) [1..] xs)

showError = putStrLn . ioeGetErrorString

extractFromMaybe :: Monad m => String -> Maybe a -> m a
extractFromMaybe err Nothing  = fail err 
extractFromMaybe _   (Just v) = return v

changeFileExtension filename oldextension newextension 
  | reverse ('.':oldextension) `isPrefixOf` emanelif 
              = reverse (drop (length oldextension) emanelif) ++ newextension
  | otherwise = filename ++ "." ++ newextension
  where
    emanelif = reverse filename

