
import Maybe
import System
import List
import Char

import Useful
import Parser

import AffineFunctions
import Input
import FileHandling
import UserInput

import Graph
import Interval
import Signature
import Generator
import Successor
import Version

program_name = "showsigs"
program_description = "Show the signatures from an edge to another "++version
program_usage =
    "\nUsage: "++program_name++" <file.spdi> <source> <destination>\n"++
    "  where:\n"++
    "    <file.spdi> is the name of the input file\n"++
    "    <source> and <destination> are both edges specified as two point\n"++
    "      labels separated by a dash (eg 1-2)"
parse_arguments = (parseFilenameExtension "spdi", (parseEdge, parseEdge)) 

main =
  do { (filename, (src, dst)) <- runProgram (program_description, program_usage) parse_arguments
     ; (input, point2vector, points2edgeID,edgeID2points) <- fileToInput filename
     ; src' <- readUnambiguousEdge (point2vector, points2edgeID) src
     ; dst' <- readUnambiguousEdge (point2vector, points2edgeID) dst
     ; let graph = makeGraph input
     ; let (_,signatures,loops) = generateSignatures graph src' dst'
     ; putStrLn ("Closure loops which may be added to the end of signatures:")
     ; putStrLn (enumerateShow (showPath edgeID2points) loops)
     ; putStrLn ("Generating normal signatures from edge "++
         showStringEdge src++" to "++
         showStringEdge dst++" ...")
     ; putStrLn (enumerateShow (showSignature edgeID2points) signatures)
     ; putStrLn ("Total number of combined signatures: "++
         show ((length loops + 1) * length signatures)++"\n")
     } `catch` showError


